# coding: utf-8

"""
    Metal API

    # Introduction Equinix Metal provides a RESTful HTTP API which can be reached at <https://api.equinix.com/metal/v1>. This document describes the API and how to use it.  The API allows you to programmatically interact with all of your Equinix Metal resources, including devices, networks, addresses, organizations, projects, and your user account. Every feature of the Equinix Metal web interface is accessible through the API.  The API docs are generated from the Equinix Metal OpenAPI specification and are officially hosted at <https://metal.equinix.com/developers/api>.  # Common Parameters  The Equinix Metal API uses a few methods to minimize network traffic and improve throughput. These parameters are not used in all API calls, but are used often enough to warrant their own section. Look for these parameters in the documentation for the API calls that support them.  ## Pagination  Pagination is used to limit the number of results returned in a single request. The API will return a maximum of 100 results per page. To retrieve additional results, you can use the `page` and `per_page` query parameters.  The `page` parameter is used to specify the page number. The first page is `1`. The `per_page` parameter is used to specify the number of results per page. The maximum number of results differs by resource type.  ## Sorting  Where offered, the API allows you to sort results by a specific field. To sort results use the `sort_by` query parameter with the root level field name as the value. The `sort_direction` parameter is used to specify the sort direction, either either `asc` (ascending) or `desc` (descending).  ## Filtering  Filtering is used to limit the results returned in a single request. The API supports filtering by certain fields in the response. To filter results, you can use the field as a query parameter.  For example, to filter the IP list to only return public IPv4 addresses, you can filter by the `type` field, as in the following request:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/projects/id/ips?type=public_ipv4 ```  Only IP addresses with the `type` field set to `public_ipv4` will be returned.  ## Searching  Searching is used to find matching resources using multiple field comparissons. The API supports searching in resources that define this behavior. Currently the search parameter is only available on devices, ssh_keys, api_keys and memberships endpoints.  To search resources you can use the `search` query parameter.  ## Include and Exclude  For resources that contain references to other resources, sucha as a Device that refers to the Project it resides in, the Equinix Metal API will returns `href` values (API links) to the associated resource.  ```json {   ...   \"project\": {     \"href\": \"/metal/v1/projects/f3f131c8-f302-49ef-8c44-9405022dc6dd\"   } } ```  If you're going need the project details, you can avoid a second API request.  Specify the contained `href` resources and collections that you'd like to have included in the response using the `include` query parameter.  For example:  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=projects ```  The `include` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests where `href` resources are presented.  To have multiple resources include, use a comma-separated list (e.g. `?include=emails,projects,memberships`).  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=emails,projects,memberships ```  You may also include nested associations up to three levels deep using dot notation (`?include=memberships.projects`):  ```sh curl -H 'X-Auth-Token: my_authentication_token' \\   https://api.equinix.com/metal/v1/user?include=memberships.projects ```  To exclude resources, and optimize response delivery, use the `exclude` query parameter. The `exclude` parameter is generally accepted in `GET`, `POST`, `PUT`, and `PATCH` requests for fields with nested object responses. When excluded, these fields will be replaced with an object that contains only an `href` field. 

    The version of the OpenAPI document: 1.0.0
    Contact: support@equinixmetal.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest
import datetime

import equinix_metal_t0mk
from equinix_metal_t0mk.models.plan_list import PlanList  # noqa: E501
from equinix_metal_t0mk.rest import ApiException

class TestPlanList(unittest.TestCase):
    """PlanList unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional):
        """Test PlanList
            include_option is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `PlanList`
        """
        model = equinix_metal_t0mk.models.plan_list.PlanList()  # noqa: E501
        if include_optional :
            return PlanList(
                href = '', 
                plans = [
                    equinix_metal_t0mk.models.plan.Plan(
                        available_in = [
                            equinix_metal_t0mk.models.plan_available_in_inner.Plan_available_in_inner(
                                href = '', 
                                price = equinix_metal_t0mk.models.plan_available_in_inner_price.Plan_available_in_inner_price(
                                    hour = 1.23, 
                                    href = '', ), )
                            ], 
                        available_in_metros = [
                            equinix_metal_t0mk.models.plan_available_in_metros_inner.Plan_available_in_metros_inner(
                                href = '', )
                            ], 
                        categories = [
                            ''
                            ], 
                        class = 'm3.large.x86', 
                        deployment_types = [
                            'on_demand'
                            ], 
                        description = '', 
                        href = '', 
                        id = '', 
                        legacy = True, 
                        line = '', 
                        name = '', 
                        pricing = equinix_metal_t0mk.models.pricing.pricing(), 
                        slug = 'm3.large.x86', 
                        specs = equinix_metal_t0mk.models.plan_specs.Plan_specs(
                            cpus = [
                                equinix_metal_t0mk.models.plan_specs_cpus_inner.Plan_specs_cpus_inner(
                                    count = 56, 
                                    href = '', 
                                    type = '', )
                                ], 
                            drives = [
                                equinix_metal_t0mk.models.plan_specs_drives_inner.Plan_specs_drives_inner(
                                    category = 'boot', 
                                    count = 56, 
                                    href = '', 
                                    size = '3.84TB', 
                                    type = '', )
                                ], 
                            features = equinix_metal_t0mk.models.plan_specs_features.Plan_specs_features(
                                href = '', 
                                raid = True, 
                                txt = True, 
                                uefi = True, ), 
                            href = '', 
                            memory = equinix_metal_t0mk.models.plan_specs_memory.Plan_specs_memory(
                                href = '', 
                                total = '', ), 
                            nics = [
                                equinix_metal_t0mk.models.plan_specs_nics_inner.Plan_specs_nics_inner(
                                    count = 2, 
                                    href = '', 
                                    type = '', )
                                ], ), 
                        type = 'standard', )
                    ]
            )
        else :
            return PlanList(
        )
        """

    def testPlanList(self):
        """Test PlanList"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
